﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;

namespace WindowsFormsApplication1.WebTest.WebTestXmlNodes
{
    public class NodeDescriptionProperties
    {
        public enum WebTestNodeTypes
        {
            Attribute,
            Content,
            Parameter
        }

        public NodeDescriptionProperties(GenericWebTestNode parentNode)
        {
            ParentNode = parentNode; 

            TagName = "UnknownTag";
            Category = "UnknownCategory";
            ParameterType = typeof (string);
            Name = "UnknownName";
            Value = "UnknownValue";
            Visible = true;
            Readonly = false;
            Description = string.Empty;
        }

        public string TagName;
        public string Category;
        public Type ParameterType;
        public string Name;
        public string Value;
        public bool Visible;
        public bool Readonly;
        public string Description;
        public XmlNodeType OriginalXmlNodeType;
        public WebTestNodeTypes WebTestNodeType;

        //Weight used while comparing nodes
        public int Weight;

        public GenericWebTestNode ParentNode;
    }
}
