﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;

namespace WindowsFormsApplication1.WebTest.WebTestXmlNodes
{
    [XmlRoot("ExtractionRule", Namespace = XmlNamespace)]
    public class ExtractionRuleNode : GenericWebTestNode, IXmlSerializable
    {
        private RuleParametersNode _ruleParameters;

        public override void SetNodeProperties()
        {
            SelectedImageIndex = 3;
            ImageIndex = 3;

            Text = "Extraction Rule";
        }

        #region IXmlSerializable Members

        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(XmlReader reader)
        {
            Notification.BeginOperation("Processing ExtractionRuleNode", NodeOperationEventArgs.EventImportance.Detailed);
            
            //Read Extraction Rule attributes
            ReadXmlAttributes(reader);

            //Set node properties such as Icon, Text, etc..
            SetNodeProperties();

            //Read Extraction Rule opening tag
            reader.MoveToContent();
            bool isEmptyElement = reader.IsEmptyElement;

            reader.Read();
            reader.MoveToContent();

            #region Read rules parameters

            bool exitLoop = false;
            while (!isEmptyElement && reader.NodeType != XmlNodeType.EndElement)
            {
                //Process sub tags
                switch (reader.Name)
                {
                    case "RuleParameters":
                        var ruleParameters = (RuleParametersNode)_ruleParametersNodeSerializer.Deserialize(reader);
                        foreach (var propertyName in ruleParameters.NodeProperties.Keys)
                            _nodeProperties.Add(propertyName, ruleParameters.NodeProperties[propertyName]);

                        _ruleParameters = ruleParameters;

                        break;

                    default:
                        Notification.DebugMessage("Unknown tag: " + reader.Name);
                        exitLoop = true;
                        break;
                }

                reader.MoveToContent();
                if (exitLoop) break;
            }

            #endregion

            //If there is closing tag read it
            if (!isEmptyElement)
                reader.ReadEndElement();

            Notification.EndOperation();
        }

        #endregion

    }
}
