﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;

namespace WindowsFormsApplication1.WebTest.WebTestXmlNodes
{
    [XmlRoot("CorrelationExtractionRules", Namespace = XmlNamespace)]
    public class CorrelationExtractionRulesNode : GenericWebTestNode, IXmlSerializable
    {

        public override void SetNodeProperties()
        {
            SelectedImageIndex = 4;
            ImageIndex = 4;

            Text = "CorrelationExtractionRules";
        }

        #region IXmlSerializable Members

        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(System.Xml.XmlReader reader)
        {
            Notification.BeginOperation("Processing CorrelationExtractionRules Node", NodeOperationEventArgs.EventImportance.Detailed);

            //Read CorrelationExtractionRules folder attributes
            ReadXmlAttributes(reader);

            //Set node properties such as Icon, Text, etc..
            SetNodeProperties();

            //Read the <CorrelationExtractionRules> opening tag
            reader.MoveToContent();
            bool isEmptyElement = reader.IsEmptyElement;

            reader.Read();
            reader.MoveToContent();

            bool exitLoop = false;
            while (!isEmptyElement && reader.NodeType != XmlNodeType.EndElement)
            {
                //Process sub tags
                switch (reader.Name)
                {
                    case "ExtractionRule":
                        var extractionRule = (ExtractionRuleNode) _extractionRuleNodeSerializer.Deserialize(reader);
                        Nodes.Add(extractionRule);

                        break;


                    default:
                        Notification.DebugMessage("Unknown tag: " + reader.Name);
                        exitLoop = true;
                        break;
                }

                reader.MoveToContent();
                if (exitLoop) break;
            }

            //If there is closing tag read it
            if (!isEmptyElement)
                reader.ReadEndElement();

            Notification.EndOperation();
        }


        #endregion


    }
}
