﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Serialization;

namespace WindowsFormsApplication1.WebTest.WebTestXmlNodes
{
    [XmlRoot("QueryStringParameters", Namespace = XmlNamespace)]
    public class QueryStringParametersNode : GenericWebTestNode, IXmlSerializable
    {
        public override void SetNodeProperties()
        {
            SelectedImageIndex = 4;
            ImageIndex = 4;

            Text = "QueryStringParameters";
        }

        #region IXmlSerializable Members

        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(System.Xml.XmlReader reader)
        {
            Notification.BeginOperation("Processing QueryStringParameters Node", NodeOperationEventArgs.EventImportance.Detailed);

            //Read QueryStringParameters folder attributes
            ReadXmlAttributes(reader);

            //Set node properties such as Icon, Text, etc..
            SetNodeProperties();

            //Read the <QueryStringParameters> opening tag
            reader.MoveToContent();
            bool isEmptyElement = reader.IsEmptyElement;

            reader.Read();
            reader.MoveToContent();

            bool exitLoop = false;
            while (!isEmptyElement && reader.NodeType != XmlNodeType.EndElement)
            {
                //Process sub tags
                switch (reader.Name)
                {
                    case "QueryStringParameter":
                        var queryStringParameter = (QueryStringParameterNode)_queryStringParameterNodeSerializer.Deserialize(reader);
                        Nodes.Add(queryStringParameter);

                        break;

                    default:
                        Notification.DebugMessage("Unexpected tag: " + reader.Name);
                        exitLoop = true;
                        break;
                }

                reader.MoveToContent();
                if (exitLoop) break;
            }

            //If there is closing tag read it
            if (!isEmptyElement)
                reader.ReadEndElement();

            Notification.EndOperation();
        }


        #endregion


    }
}
