﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;
using WindowsFormsApplication1.Properties;

namespace WindowsFormsApplication1.WebTest.WebTestXmlNodes
{
    [XmlRoot("ValidationRules", Namespace = XmlNamespace)]
    public class ValidationRulesNode : GenericWebTestNode, IXmlSerializable
    {

        public override void SetNodeProperties()
        {
            SelectedImageIndex = 4;
            ImageIndex = 4;

            Text = "Validation Rules";
        }

        #region IXmlSerializable Members

        public System.Xml.Schema.XmlSchema GetSchema()
        {
            return null;
        }

        public void ReadXml(System.Xml.XmlReader reader)
        {
            Notification.BeginOperation("Processing Validation Rules Node", NodeOperationEventArgs.EventImportance.Detailed);

            //Read Validation Rules folder attributes
            ReadXmlAttributes(reader);

            //Set node properties such as Icon, Text, etc..
            SetNodeProperties();

            //Read the <ValidationRules> opening tag
            reader.MoveToContent();
            bool isEmptyElement = reader.IsEmptyElement;

            reader.Read();
            reader.MoveToContent();

            bool exitLoop = false;
            while (!isEmptyElement && reader.NodeType != XmlNodeType.EndElement)
            {
                //Process sub tags
                switch (reader.Name)
                {
                    case "ValidationRule":
                        var validationRule = (ValidationRuleNode) _validationRuleNodeSerializer.Deserialize(reader);
                        Nodes.Add(validationRule);

                        break;

                    default:
                        Notification.DebugMessage("Unknown tag: " + reader.Name);
                        exitLoop = true;
                        break;
                }

                reader.MoveToContent();
                if (exitLoop) break;
            }

            if (!isEmptyElement)
                reader.ReadEndElement();

            Notification.EndOperation();
        }


        #endregion


    }
}
